-- Released under GPL v3
--------------------------------------------------------------
local mapWidth, mapHeight = Map.GetGridSize();
local fog = {};

local function OnHexFogEvent(hexPos, fogState, bWholeMap)
	if not bWholeMap then
		local x, y = ToGridFromHex( hexPos.x, hexPos.y );
		local index = mapWidth * y + x;
		fog[index] = fogState;
	end
end

-------------------------------------------------------------------------------------------------
function UnhookFog()
	Events.HexFOWStateChanged.Remove(OnHexFogEvent);
end

-------------------------------------------------------------------------------------------------
function RestoreFog()
	local teamID = Game.GetActiveTeam();

	Events.HexFOWStateChanged.Remove(OnHexFogEvent);
	Game.UpdateFOW(true);
	FOW_SetAll(1);

	for i = 0, Map.GetNumPlots()-1, 1 do
		local plot = Map.GetPlotByIndex(i);
		--plot:SetRevealed(teamID, fog[i]);
		plot:UpdateFog();
	end
	print("RestoreFog - Done")
end

-------------------------------------------------------------------------------------------------
function HideFog()
	local teamID = Game.GetActiveTeam();

	for i = 0, Map.GetNumPlots()-1, 1 do
		local plot = Map.GetPlotByIndex(i);
		fog[i] = plot:IsRevealed(teamID);
	end

	FOW_SetAll(0);
	Game.UpdateFOW(true);
	Events.HexFOWStateChanged.Add(OnHexFogEvent);
end